ACT_KAPI_ROLL = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_GROUP_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE)

ACT_KAPI_ROLL_AIR = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_GROUP_AIRBORNE | ACT_FLAG_AIR)

ACT_KAPI_DASH = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING | ACT_FLAG_MOVING)

ACT_KAPI_TWIRL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_WALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_LONG_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_DASH_CANCEL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_HIGH_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_AIR_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

ACT_KAPI_FREEFALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION) 

local kapijump = audio_sample_load("Kapijump.ogg")
local kapiroll = audio_sample_load("Kapiroll.ogg")
local kapidash = audio_sample_load("Kapidash.ogg")
local kapidashcancel = audio_sample_load("Kapidashcancel.ogg")
local kapilongjump = audio_sample_load("Kapilongjump.ogg")
local kapihighjump = audio_sample_load("Kapihighjump.ogg")
local kapiwalljump = audio_sample_load("Kapiwalljump.ogg")
local kapitwirl = audio_sample_load("Kapitwirl.ogg")
local kapiairjump = audio_sample_load("Kapiairjump.ogg")

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
    e.rotAngle = 0
end

local function act_kapi_roll(m)
  
  mario_set_forward_vel(m, 75)
  
common_slide_action(m, ACT_CROUCH_SLIDE, ACT_KAPI_ROLL_AIR, CHAR_ANIM_FORWARD_SPINNING)

  set_mario_animation(m, CHAR_ANIM_FORWARD_SPINNING)
    
    m.faceAngle.y = m.intendedYaw
    
    if m.controller.buttonDown & B_BUTTON == 0 then
      set_mario_action(m, ACT_JUMP_LAND, 0)
    end
    
    if m.action & ACT_FLAG_AIR ~= 0 then
      set_mario_action(m, ACT_KAPI_ROLL_AIR, 0)
    end
    
    end



local function act_kapi_roll_air(m)
  
  if m.actionTimer == 0 and m.prevAction ~= ACT_KAPI_ROLL then
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    audio_sample_play(kapiroll, m.pos , 5)
  end
  
  m.forwardVel = 50
  m.vel.y = -40 - m.actionTimer * 1.2
  if m.controller.stickMag ~= 0 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else
    m.faceAngle.y = m.faceAngle.y
    end
  
  common_air_action_step(m, ACT_KAPI_ROLL, CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)
  
  m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x + 0x2048
  if m.controller.buttonDown & B_BUTTON == 0 and m.actionTimer > 5 then
      set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  m.actionTimer = m.actionTimer + 1
  return
  end



local function on_set_mario_action(m)
  if m.playerIndex == 0 then
  if m.action == ACT_KAPI_DASH then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and m.actionTimer < 20 then
      set_mario_action(m, ACT_KAPI_DASH_CANCEL, 0)
      end
  end
  
 if analog_stick_held_back(m) ~= 0 and (m.action == ACT_WALKING or m.action == ACT_TURNING_AROUND) then
   set_mario_action(m, ACT_WALKING, 0)
   return set_mario_action(m, ACT_WALKING, 0)
 end
  
  if m.action == ACT_WALKING then
    if m.forwardVel > 1 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  end
  end
    
   if m.action == ACT_WALL_KICK_AIR or m.action == ACT_JUMP or m.action == ACT_FREEFALL then
     if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  set_mario_animation(m, CHAR_ANIM_DOUBLE_JUMP_RISE)
  set_anim_to_frame(m, 5)
  end
end
end



local function act_kapi_dash(m)
  local e = gStateExtras[m.playerIndex]

    local spinDirFactor = 1 
    
    if m.actionTimer == 0 then 
      audio_sample_play(kapidash, m.pos , 5)
      end
    set_mario_animation(m, CHAR_ANIM_SLIDE_DIVE)
    common_air_action_step(m, ACT_JUMP_LAND , CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)
    m.particleFlags = m.particleFlags | PARTICLE_DUST
    if m.controller.stickMag ~= 0 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else
    m.faceAngle.y = m.faceAngle.y
    end
  if m.actionTimer > 20 then
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  if m.actionTimer < 10 then
    m.forwardVel = 65
    m.vel.y = 0
    e.rotAngle = e.rotAngle + 0x2000
    if e.rotAngle > 0x32768 then 
      e.rotAngle = e.rotAngle - 0x32768
    end
    else
      e.rotAngle = 0
      end
    
    m.marioObj.header.gfx.angle.z = m.marioObj.header.gfx.angle.z + e.rotAngle
  
  m.actionTimer = m.actionTimer + 1
  return
end



local function act_kapi_twirl(m)
  local e = gStateExtras[m.playerIndex]

    local spinDirFactor = 1 
    if m.actionState == 1 then spinDirFactor = -1 end
  
  if m.actionTimer == 0 then
    audio_sample_play(kapitwirl, m.pos , 5)
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    if m.forwardVel > 25 then
    m.vel.y = 0
    m.forwardVel = m.forwardVel / 2
    else
      m.vel.y = 2
      m.forwardVel = 0
    end
end
  common_air_action_step(m, ACT_KAPI_JUMP, CHAR_ANIM_TWIRL, AIR_STEP_NONE)
  set_mario_animation(m, CHAR_ANIM_TWIRL)
  if m.vel.y < -15 then
    m.vel.y = -15 else
      m.vel.y = m.vel.y - 0.6
  end
  
  if m.controller.buttonDown & A_BUTTON == 0 and m.actionTimer > 3 then
    set_mario_action(m, ACT_KAPI_JUMP, 0)
  end
  
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  
  e.rotAngle = e.rotAngle + 0x2000
    if e.rotAngle >  0x10000 then 
      e.rotAngle = e.rotAngle - 0x10000 
      play_sound(SOUND_ACTION_TWIRL, m.pos)
      end
    m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y + e.rotAngle * spinDirFactor
  
  m.actionTimer = m.actionTimer + 1
  return 
  end



local function act_kapi_wall(m)

    if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        local rc = set_mario_action(m, ACT_KAPI_JUMP, 0)
        m.vel.y = 75
        audio_sample_play(kapiwalljump, m.pos , 5)
        m.forwardVel = 45
        m.wallKickTimer = 0
        m.faceAngle.y = m.faceAngle.y + 0x8000
        return rc
    end

    mario_set_forward_vel(m, 1)

    set_mario_animation(m, MARIO_ANIM_CLIMB_UP_POLE)

    if perform_air_step(m, 0) == AIR_STEP_LANDED then
        mario_set_forward_vel(m, 0.0)
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            return set_mario_action(m, ACT_FREEFALL_LAND, 0)
        end
    end

    m.actionTimer = m.actionTimer + 1
    if m.wall == nil and m.actionTimer > 2 then
        mario_set_forward_vel(m, 0.0)
        return set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
    m.vel.y = m.vel.y + 2
end



local function act_kapi_long_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapilongjump, m.pos , 5)
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    e.rotAngle = 0x0
    m.forwardVel = 50
    m.vel.y = 55
    end
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_FLY_FROM_CANNON, AIR_STEP_NONE)
  
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  
 if e.rotAngle < 0x10216 then
   e.rotAngle = e.rotAngle + 0x1024
   else
     end
  
   m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x + e.rotAngle
   
   if m.actionTimer == 30 then
     set_mario_action(m, ACT_KAPI_FREEFALL, 0)
     end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_high_jump(m)
  
  if m.actionTimer == 0 then
    m.pos.y = m.pos.y + 10
    audio_sample_play(kapihighjump, m.pos , 5)
    end
  if m.actionTimer < 4 then
    m.forwardVel = 0
    m.vel.y = 0
    set_mario_animation(m, CHAR_ANIM_START_CROUCHING)
  elseif m.actionTimer == 4 then
    m.vel.y = 70
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
  end
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_DOUBLE_JUMP_RISE, AIR_STEP_NONE)
  
  m.faceAngle.y = m.intendedYaw
  
  m.actionTimer = m.actionTimer + 1
  return
  end

local function act_kapi_jump(m)
  
  if m.actionTimer == 0 then
    audio_sample_play(kapijump, m.pos , 5)
    m.vel.y = 45
  end
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_DOUBLE_JUMP_RISE, AIR_STEP_NONE)
  set_mario_animation(m, CHAR_ANIM_DOUBLE_JUMP_RISE)
  
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_dash_cancel(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapidashcancel, m.pos , 5)
   m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    e.rotAngle = 0x0
    m.vel.y = 45
    m.forwardVel = 55
  end
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_TWIRL, AIR_STEP_NONE)
  if m.actionTimer < 12 then
  set_mario_animation(m, CHAR_ANIM_RIDING_SHELL)
  else
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y + e.rotAngle
  
  if e.rotAngle < 0x10216 then
   e.rotAngle = e.rotAngle + 0x2048
   else
     end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_air_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapiairjump, m.pos , 5)
    e.rotAngle = 0x10216
  end
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_TWIRL, AIR_STEP_NONE)
  if m.actionTimer < 12 then
  set_mario_animation(m, CHAR_ANIM_FLY_FROM_CANNON)
  else
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  
  if m.actionTimer < 2 and m.action == ACT_KAPI_AIR_JUMP then
    m.vel.y = 0
    m.forwardVel = 0
    else
  if e.rotAngle > 0x0 then
   e.rotAngle = e.rotAngle - 0x2048
   else
  end
  m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y - e.rotAngle
  end
  if m.actionTimer == 2 then
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    m.forwardVel = 60
    m.vel.y = 30
    end
   
   m.actionTimer = m.actionTimer + 1
   return
end
 
 
 
 local function act_kapi_freefall(m)
 
 common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_DOUBLE_JUMP_FALL, AIR_STEP_NONE)
 
 if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end

m.actionTimer = m.actionTimer + 1 return
 end

hook_mario_action(ACT_KAPI_ROLL, { every_frame = act_kapi_roll }, INT_GROUND_POUND_OR_TWIRL)
hook_mario_action(ACT_KAPI_ROLL_AIR, { every_frame = act_kapi_roll_air }, INT_GROUND_POUND_OR_TWIRL)
hook_mario_action(ACT_KAPI_WALL, { every_frame = act_kapi_wall })
hook_mario_action(ACT_KAPI_DASH, { every_frame = act_kapi_dash })
hook_mario_action(ACT_KAPI_TWIRL, { every_frame = act_kapi_twirl })
hook_mario_action(ACT_KAPI_LONG_JUMP, { every_frame = act_kapi_long_jump })
hook_mario_action(ACT_KAPI_HIGH_JUMP, { every_frame = act_kapi_high_jump })
hook_mario_action(ACT_KAPI_JUMP, { every_frame = act_kapi_jump })
hook_mario_action(ACT_KAPI_DASH_CANCEL, { every_frame = act_kapi_dash_cancel })
hook_mario_action(ACT_KAPI_AIR_JUMP, { every_frame = act_kapi_air_jump })
hook_mario_action(ACT_KAPI_FREEFALL, { every_frame = act_kapi_freefall})
hook_event(HOOK_MARIO_UPDATE, on_set_mario_action)